# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DeploymentManager::Mgmt::V2018_09_01_preview
  module Models
    #
    # Defines a specific step on a target service unit.
    #
    class RolloutStep

      include MsRestAzure

      # @return [String] Name of the step.
      attr_accessor :name

      # @return [String] Current state of the step.
      attr_accessor :status

      # @return [String] The step group the current step is part of.
      attr_accessor :step_group

      # @return [StepOperationInfo] Detailed information of specific action
      # execution.
      attr_accessor :operation_info

      # @return [Array<ResourceOperation>] Set of resource operations that were
      # performed, if any, on an Azure resource.
      attr_accessor :resource_operations

      # @return [Array<Message>] Supplementary informative messages during
      # rollout.
      attr_accessor :messages


      #
      # Mapper for RolloutStep class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RolloutStep',
          type: {
            name: 'Composite',
            class_name: 'RolloutStep',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              step_group: {
                client_side_validation: true,
                required: false,
                serialized_name: 'stepGroup',
                type: {
                  name: 'String'
                }
              },
              operation_info: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'operationInfo',
                type: {
                  name: 'Composite',
                  class_name: 'StepOperationInfo'
                }
              },
              resource_operations: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'resourceOperations',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ResourceOperationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ResourceOperation'
                      }
                  }
                }
              },
              messages: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'messages',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MessageElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Message'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
